<?php
/**
  _____________________________________________________________________________
 |
 | Widget Template
 |
 | @project     Chameleon
 | @revision    $Id: $
 | @purpose     Widget template.
 | @author      DM Solutions Group (wbronsema@dmsolutions.ca)
 | @copyright
 | <b>Copyright (c) 2005 DM Solutions Group Inc.</b>
 | Permission is hereby granted, free of charge, to any person obtaining a
 | copy of this software and associated documentation files (the "Software"),
 | to deal in the Software without restriction, including without limitation
 | the rights to use, copy, modify, merge, publish, distribute, sublicense,
 | and/or sell copies of the Software, and to permit persons to whom the
 | Software is furnished to do so, subject to the following conditions:
 |
 | The above copyright notice and this permission notice shall be included
 | in all copies or substantial portions of the Software.
 |
 | THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 | IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 | FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
 | THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 | LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 | FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 | DEALINGS IN THE SOFTWARE.
 |_____________________________________________________________________________

 **/

// inherit from the NavTool
include_once(dirname(__FILE__)."/../NavTool.php");

/**
  _____________________________________________________________________________
 |
 | "WidgetTemplate" Widget Class
 |_____________________________________________________________________________

 **/
class WidgetTemplate extends NavTool
{
    // define member vars
    // i.e.  var $mszMyVariable;
    
    /////////  ADD MEMBER VARS HERE  /////////
    
    /**
      _________________________________________________________________________
     |
     | Constructor: "WidgetTemplate" Widget Class
     |_________________________________________________________________________

     **/
    function WidgetTemplate()
    {
        // set the language file
        $this->mszLanguageResource = dirname(__FILE__).'/WidgetTemplate.dbf';

        // invoke constructor of parent
        parent::NavTool();

       /**
         ______________________________________________________________________
        |
        | Define Attributes
        |
        | Example:
        | $this->maAttributes['MYSTRING'] = 
        |                      new StringAttribute( 'MYSTRING', false );
        | $this->maAttributes['MYCOLOR'] = 
        |                      new RGBColorAttribute( 'MYCOLOR', false );
        | $this->maAttributes['MYINT'] = 
        |                      new IntegerAttribute( 'MYINT', false, 1 );
        | $this->maAttributes['MYBOOLEAN'] = 
        |                      new BooleanAttribute( 'MYBOOLEAN', false );
        |______________________________________________________________________

        **/

        /////////  ADD ATTRIBUTES HERE  /////////
       
        // set the description for this widget
        $this->szWidgetDescription = <<<EOT
This is the WidgetTemplate.
EOT;
        // set the maturity level
        $this->mnMaturityLevel = MATURITY_ALPHA;

    // end constructor
    }

    /**
      _________________________________________________________________________
     |
     |  InitDefaults()
     |
     |  Use this section to set any predetermined variables or default vaules
     |
     |  Postcondition:  Initialize defaults.
     |
     |  @return n/a
     |  @desc Initialize defaults.
     |_________________________________________________________________________

     **/
    function InitDefaults()
    {
        // init defaults for parent
        parent::InitDefaults();
        
        /////////  ADD CODE HERE IF NECESSARY /////////

    // end InitDefaults function.
    }

    /**
      _________________________________________________________________________
     |
     |  ParseURL()
     |
     |  Use this function to process any information or changes passed in the
     |  URL.  Set any appropriate member variables.  This section should NOT
     |  be used to output any HTML to the screen.
     |
     |  Postcondition:  This function parses information passed on the URL and
     |                  acts on it.
     |
     |  @return boolean - True if successful, false if not.
     |  @desc Parses info passed on URL.
     |_________________________________________________________________________

     **/
    function  ParseURL()
    {
        // execute parent function
        parent::ParseURL();
        
        /////////  ADD CODE HERE IF NECESSARY /////////

        // return success
        return true;
    }

    /**
      _________________________________________________________________________
     |
     |  DrawPublish()
     |
     |  OPTIONAL - Use this function to build any html output specific to the 
     |  widget interface.
     |
     |  Postcondition:  This function builds the html output for the physical
     |                  appearance of the widget.
     |
     |  @return string - Output
     |  @desc Generates HTML output for the widget.
     |_________________________________________________________________________

     **/
    
/**  REMOVE THIS LINE TO USE THIS FUNCTION
    
    function DrawPublish()
    {
        // init vars
        $szReturn = '';
        
        // execute parent
        $szReturn .= parent::DrawPublish();

        /////////  ADD CODE HERE IF NECESSARY /////////      
        
        // return
        return $szReturn;

    // end DrawPublish() function
    }
    
    /**
      _________________________________________________________________________
     |
     |  GetHTMLHiddenVariables()
     |
     |  OPTIONAL - Use this function to define any hidden html form variables
     |  required by the widget.
     |
     |  Postcondition:  This function defines html form variables and adds
     |                  them to the array.
     |
     |  Example:
     |
     |  $szVariable = "MY_HIDDEN_VAR";
     |  $szValue = " <INPUT TYPE=HIDDEN NAME=$szVariable VALUE=\"0\">";
     |  $aReturn[$szVariable] = $szValue;
     |
     |  @return Array - Array of html form variables.
     |  @desc Defines html form variables.
     |_________________________________________________________________________

     **/

/**  REMOVE THIS LINE TO USE THIS FUNCTION

    function GetHTMLHiddenVariables()
    {
        // init vars
        $aReturn = parent::GetHTMLHiddenVariables();

        /////////  ADD CODE HERE IF NECESSARY /////////
        
        // return
        return $aReturn;
        
    // end GetHTMLHiddenVariables() function
    }    

    /**
      _________________________________________________________________________
     |
     |  GetJavascriptIncludeFunctions()
     |
     |  OPTIONAL - Use this function to include any external javascript files 
     |  that are required by the widget.
     |
     |  Postcondition:  This function defines the javascript include statements.
     |
     |  Example:
     |
     |  $szVar = "myjavascript.js";
     |  $aReturn[$szVar] = '<script src="http://myjavascript.js" 
     |                                     type="text/javascript"></script>';
     |
     |
     |  @return Array - Array of include statements.
     |  @desc Defines javascript include statements.
     |_________________________________________________________________________

     **/

/**  REMOVE THIS LINE TO USE THIS FUNCTION

    function GetJavascriptIncludeFunctions()
    {
        // init vars
        $aReturn = parent::GetJavascriptIncludeFunctions();

        /////////  ADD CODE HERE IF NECESSARY /////////
        
        // return
        return $aReturn;

    // end GetJavascriptIncludeFunctions() function
    }
    
    /**
      _________________________________________________________________________
     |
     |  GetJavascriptVariables()
     |
     |  OPTIONAL - Use this function to define any javascript variables that 
     |  are required by this widget.
     |
     |  Postcondition:  This function defines javascript variables and adds
     |                  them to the array.
     |
     |  Example:
     |
     |  $aReturn['MyJSVar'] = 'var szMyJSVar = "Default Value";'."\n";
     |
     |  @return Array - Array of javascript variables.
     |  @desc Defines javascript variables.
     |_________________________________________________________________________

     **/

/**  REMOVE THIS LINE TO USE THIS FUNCTION

    function GetJavascriptVariables()
    {
        // init vars
        $aReturn = parent::GetJavascriptVariables();

        /////////  ADD CODE HERE IF NECESSARY /////////
        
        // return
        return $aReturn;

    // end GetJavascriptVariables() function
    }    
    
    /**
      _________________________________________________________________________
     |
     |  GetJavascriptFunctions()
     |
     |  OPTIONAL - Use this function to define all javascript functions needed 
     |  by this widget
     |
     |  Postcondition:  This function defines javascript functions and adds
     |                  them to the array.
     |
     |  Example:
     |
     |    $szJsFunctionName = "myJSFunction";
     |    $szFunction = <<<EOT
     |    function {$szJsFunctionName}()
     |    {
     |        alert('myJSFunction');
     |        return true;
     |    }
     |    EOT;
     |    $aReturn[$szJsFunctionName] = $szFunction;
     |
     |
     |  @return Array - Array of javascript functions.
     |  @desc Defines javascript functions.
     |_________________________________________________________________________

     **/

/**  REMOVE THIS LINE TO USE THIS FUNCTION

    function GetJavascriptFunctions()
    {
        // init vars
        $aReturn = parent::GetJavascriptFunctions();
        
        /////////  ADD CODE HERE IF NECESSARY /////////

        // return
        return $aReturn;

    // end GetJavascriptFunctions() function
    }    
    
    /**
      _________________________________________________________________________
     |
     |  GetJavascriptInitFunctions()
     |
     |  OPTIONAL - Use this function to define a list of functions that need
     |  to run to initialize this widget's javascript variables.
     |
     |  Postcondition:  This function defines the list javascript functions 
     |                  and adds them to the array.
     |
     |  Example:
     |
     |  $aReturn['MyInitFunction'] = "MyInitFunction();\n";
     |
     |  @return Array - Array of javascript functions.
     |  @desc Defines javascript functions.
     |_________________________________________________________________________

     **/

/**  REMOVE THIS LINE TO USE THIS FUNCTION

    function GetJavascriptInitFunctions()
    {
        // call parent function
        $aReturn = parent::GetJavascriptInitFunctions();

        /////////  ADD CODE HERE IF NECESSARY /////////

        // return
        return $aReturn;

    // end GetJavascriptInitFunctions() function
    }

    /**
      _________________________________________________________________________
     |
     |  GetJavascriptOnLoadFunctions()
     |
     |  OPTIONAL - Use this function to define the list of javascript functions
     |  to execute in the onload function of the widget.
     |
     |  Postcondition:  This function defines javascript functions and adds
     |                  them to the array.
     |
     |  Example:
     |
     |  $aReturn['MyOnloadFunction'] = "MyOnloadFunction();\n";
     |
     |  @return Array - Array of javascript functions.
     |  @desc Defines javascript functions.
     |_________________________________________________________________________

     **/

/**  REMOVE THIS LINE TO USE THIS FUNCTION

    function GetJavascriptOnLoadFunctions()
    {
        // init vars
        $aReturn = parent::GetJavascriptOnLoadFunctions();
        
        /////////  ADD CODE HERE IF NECESSARY /////////

        // return
        return $aReturn;

    // end GetJavascriptOnLoadFunctions() function
    }    
    
    /**
      _________________________________________________________________________
     |
     |  GetJavascriptOnMouseMoveFunctions()
     |
     |  OPTIONAL - Use this function to define the list of javascript functions
     |  to execute on a mouse move event.
     |  
     |  Postcondition:  This function defines mouse move functions and adds
     |                  them to the array.
     |
     |  Example:
     |
     |  $szJsFunctionName = "MyMouseMove";
     |  $szFunction = "$szJsFunctionName(e);\n";
     |  $aReturn[$szJsFunctionName] = $szFunction;
     |
     |  @return Array - Array of mouse move functions.
     |  @desc Defines mouse move functions.
     |_________________________________________________________________________

     **/

/**  REMOVE THIS LINE TO USE THIS FUNCTION

    function GetJavascriptOnMouseMoveFunctions()
    {
        // init vars
        $aReturn = parent::GetJavascriptOnMouseMoveFunctions();

        /////////  ADD CODE HERE IF NECESSARY /////////

        // return
        return $aReturn;
        
    // end GetJavascriptOnMouseMoveFunctions() function
    }
    
/** **/

// end "WidgetTemplate"
}
?>
